<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>D09/EX01</title>
    <script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
</head>
<body>

    <input type="text" id="left">
    <select id="opr">
        <option value="+">+</option>
        <option value="-">-</option>
        <option value="*">*</option>
        <option value="/">/</option>
        <option value="%">%</option>
    </select>
    <input type="text" id="right">
    <input type="submit" id="submit" value="Try me!">

    <script>

        let clock = 0;

        $('#submit').on('click', function () {
            resetTimeout();

            if (!$('#left').val().trim().match(/^[0-9]+$/))
                return alertLog('Error :(');

            if (!$('#right').val().trim().match(/^[0-9]+$/))
                return alertLog('Error :(');

            let lval = Number($('#left').val().trim());
            let rval = Number($('#right').val().trim());
            let oprval = $('#opr').val();

            if ((oprval === '/' || oprval === '%') && rval == 0)
                return alertLog('It\'s over 9000!');

            let res = eval(`${lval}${oprval}${rval}`);
            alertLog(res);
        });

        $('#left').on('input', () => resetTimeout());
        $('#right').on('input', () => resetTimeout());
        $('#opr').on('change', () => resetTimeout());

        // The PDF asks us to show a pop-up asking the user to use the page.
        // This could be done using setInterval to call a function that does
        // that every 30 seconds no matter what, but that doesn't really make
        // sense.
        //
        // setInterval(() => window.alert('Please, use me...'), 30000);
        //
        // What I did was have a setTimeout for 30 seconds that I reset every
        // time the user changes something in the page. Meaning it will only
        // ask to be used if it wasn't used for the past 30 seconds.
        startTimeout();

        function onTimeout() {
            window.alert('Please, use me...');
            startTimeout();
        }

        function resetTimeout() {
            clearTimeout(clock);
            startTimeout();
        }

        function startTimeout() {
            clock = setTimeout(onTimeout, 30000);
        }

        // The PDF is confusing as to what is pop-up only and what is supposed
        // to be logged to the console. Assuming it wants results and erros
        // both alerted and logged this function will be used.
        function alertLog(msg) {
            console.log(msg);
            window.alert(msg);
        }

    </script>

</body>
</html>
